
#ifndef _CAMPAIGN_H
#define _CAMPAIGN_H

#include "stdincl.h"
#include "story_entity.h"


class World;

class Campaign : public StoryEntity {

 public:
  Campaign ();
  ~Campaign ();

  StoryEntity* currentEntity;

  virtual ErrorMessage init();
  virtual ErrorMessage start();
  virtual ErrorMessage start(int storyID);
  virtual ErrorMessage stop();
  virtual ErrorMessage pause();
  virtual ErrorMessage resume();

  virtual void destroy();

  void addEntity(StoryEntity* se, int storyID);
  void addEntity(StoryEntity* se);
  void removeEntity(int storyID);
  void removeEntity(StoryEntity* se);
  
  void nextLevel();
  void previousLevel();

 private:
  ListTemplate<StoryEntity>* entities;
  bool running;

  StoryEntity* getStoryEntity(int storyID);
};

#endif /* _CAMPAIGN_H */
