/*!
  \file orxonox_gui_exec.h
  \brief File that holds the class that creates the execute-Options.
*/

#ifndef _ORXONOX_GUI_EXEC_H
#define _ORXONOX_GUI_EXEC_H

#include "orxonox_gui.h"
#include <stdio.h>
using namespace std;

//! Class that creates the execute-Options.
class OrxonoxGuiExec
{
 private:
  Frame* execFrame;            //!< The Frame that holds the ExecutionOptions.
  Box* execBox;                //!< The Box that holds the ExecutionOptions.
  Button* start;               //!< The start Button of orxonox.
  CheckButton* saveSettings;   //!< A CheckBox for if the Options should be saved.
  Menu* verboseMode;           //!< A Menu for setting the verbose-Mode. \todo setting up a verbose-class.
  CheckButton* alwaysShow;     //!< A CheckButton, for if orxonox should start with or without gui.
  Button* quit;                //!< A Button to quit the Gui without starting orxonox.
  char* configFile;            //!< The name of the .orxonox.conf(ig)-file.
  FILE* CONFIG_FILE;           //!< Filehandler for reading and writing.

 public:
  OrxonoxGuiExec (Window* orxonoxGUI);
  ~OrxonoxGuiExec ();
  
  Widget* getWidget ();
  
  void setFilename (char* filename);
  int shouldsave ();
  void writeToFile (Widget* widget);
  void writeFileText (Widget* widget, int depth);
  void readFromFile (Widget* widget);
  void readFileText (Widget* widget, char* variableName, char* variableValue, int depth);
  Widget* locateGroup(Widget* widget, char* groupName, int depth);

};
#ifdef HAVE_GTK2
  gint startOrxonox (GtkWidget *widget, Widget* data);
#endif /* HAVE_GTK2 */
#endif /* _ORXONOX_GUI_EXEC_H */
